rawset(_G, "DoAE_DraftTable", {})

-- NEVER FORGET TO ADD THIS OR DESYNC WILL HAPPEN
addHook("NetVars", function(net)
	DoAE_DraftTable = net($)
end)

-- Draft dice spawn func
addHook("MapThingSpawn", function(mobj, thing)
    if modeattacking == true P_RemoveMobj(mobj) return end -- not in Time Attack

	mobj.scale = $*2;
    -- TODO: this will be used for HUD
	mobj.DoAEdraft_ID = thing.args[0]

    -- color select
    mobj.DoAEdice_color = P_RandomRange(1,6)
        if mobj.DoAEdice_color == 1 -- red
			mobj.color = 22
		elseif mobj.DoAEdice_color == 2 -- blue
			mobj.color = 84
		elseif mobj.DoAEdice_color == 3 -- silver
			mobj.color = 72
		elseif mobj.DoAEdice_color == 4 -- green
			mobj.color = 55
		elseif mobj.DoAEdice_color == 5 -- gold
			mobj.color = 40
		elseif mobj.DoAEdice_color == 6 -- purple
			mobj.color = 95
		end

    local rollnum = P_RandomKey(100)
        -- value select
        if mobj.DoAEdice_color <= 4     -- normal dices
            if rollnum < 15
            mobj.DoAEvalue = 3
            elseif rollnum < 50
            mobj.DoAEvalue = 2
            else
            mobj.DoAEvalue = 1
            end
        elseif mobj.DoAEdice_color == 5 -- Gold dice
            mobj.DoAEvalue = 1
        else                            -- random dice
            if rollnum < 15
            mobj.DoAEvalue = 4
            elseif rollnum < 30
            mobj.DoAEvalue = 3
            elseif rollnum < 60
            mobj.DoAEvalue = 2
            else
            mobj.DoAEvalue = 1
            end
        end

    -- sprite stuff
    if mobj.DoAEvalue == 1
        mobj.frame = B
    elseif mobj.DoAEvalue == 2
        mobj.frame = C
    elseif mobj.DoAEvalue == 3
        mobj.frame = D
    elseif mobj.DoAEvalue == 4
        mobj.frame = E
    elseif mobj.DoAEvalue == 5 
        mobj.frame = F
    elseif mobj.DoAEvalue == 6 
        mobj.frame = G
    end

    table.insert(DoAE_DraftTable, mobj)

    -- natural fuse timer
    mobj.fuse = TICRATE*30
    
	--print(mobj.DoAEdraft_ID)
end, MT_BADGDRAFT)

addHook("MobjThinker", function(mobj)
    --print("object" + mobj.DoAEdraft_ID +":" + mobj.DoAEvalue)
    if DoAE_Active == false return end; -- only in Badger map

end, MT_BADGDRAFT)



addHook("TouchSpecial", function(mobj, pl)
    if pl.player.Pickdraftdice == true return true end
    -- les dataminers vont vomir en voyant ces multiple façons de faire le même truc, mais faut le mod soit shippé avent 2025
    if mobj.color == 22 -- red
        -- red accel
        pl.player.DoAE.RedDice = $+mobj.DoAEvalue
    elseif mobj.color == 84 -- blue
        --Blue speed
        pl.player.DoAE.BlueDice = $+mobj.DoAEvalue
    elseif mobj.color == 72 -- silver
        -- Silver Iframes
        pl.player.DoAE.SilverDice = $+mobj.DoAEvalue
    elseif mobj.color == 55 -- green
        -- Green drift spark
        pl.player.DoAE.GreenDice = $+mobj.DoAEvalue
    elseif mobj.color == 40 -- gold
        -- all
        pl.player.DoAE.RedDice = $+mobj.DoAEvalue
        pl.player.DoAE.BlueDice = $+mobj.DoAEvalue
        pl.player.DoAE.SilverDice = $+mobj.DoAEvalue
        pl.player.DoAE.GreenDice = $+mobj.DoAEvalue
    elseif mobj.color == 95 -- purple
        -- random
        if leveltime%4 == 0 pl.player.DoAE.RedDice = $+mobj.DoAEvalue
        elseif leveltime%4 == 1 pl.player.DoAE.BlueDice = $+mobj.DoAEvalue
        elseif leveltime%4 == 2 pl.player.DoAE.SilverDice = $+mobj.DoAEvalue
        elseif leveltime%4 == 3 pl.player.DoAE.GreenDice = $+mobj.DoAEvalue
        end
    end

    -- now has picked one, and cannot get another one
    pl.player.Pickdraftdice = true
	S_StartSound(pl, sfx_whspc7)
end, MT_BADGDRAFT)