local dicepositionX = 0;
local dicepositionY = 0;
local diceflags = 0

/*
    -- Optimise this
*/

-- dice HUD blinking
addHook("PlayerThink", function(player)
    if DoAE_Active == false return end; -- only in Badger map
    if displayplayers[0] != player return end;
    if player.DoAE.DropInvun > 0
        if leveltime%4 > 1 diceflags = V_HUDTRANSHALF
        else diceflags = V_80TRANS end
    else  diceflags = 0 end
    --if player.bot == false print(player.DoAE.DropInvun) end
end)

local function DoAEsorting(min, max)
    --if not (min.valid) or (max.valid) return end;
	if DoAE_Active == false return end;
    return min.DoAEdraft_ID < max.DoAEdraft_ID
end

-- draft ordering
addHook("ThinkFrame", function()
    if DoAE_Active == false return end; -- only in Badger map
    if modeattacking == true return end
    --print(DoAE_Active)
	if leveltime == 5
        table.sort(DoAE_DraftTable, DoAEsorting)
		-- for _,i in ipairs(DoAE_DraftTable) do
		-- 	print(i.DoAEdraft_ID + " : " + i.DoAEdice_color)
		-- end
	end
end)

local function Badgerhud(v, player)
    if DoAE_Active == false return end;
    -----------------------------------------------------------------
    -- player dice stats
    if splitscreen == 0 -- single screen
        v.drawString((320-105), (200-30), "ACL \n  " + player.DoAE.RedDice, V_REDMAP|V_SNAPTOBOTTOM|V_SNAPTORIGHT|diceflags, "center")
        v.drawString((320-80), (200-30), "INV \n  " + player.DoAE.SilverDice, V_SNAPTOBOTTOM|V_SNAPTORIGHT|diceflags, "center")
        v.drawString((320-55), (200-30), "DFT \n  " + player.DoAE.GreenDice, V_GREENMAP|V_SNAPTOBOTTOM|V_SNAPTORIGHT|diceflags, "center")
        v.drawString((320-30), (200-30), "SPD \n  " + player.DoAE.BlueDice, V_BLUEMAP|V_SNAPTOBOTTOM|V_SNAPTORIGHT|diceflags, "center")

    elseif splitscreen == 1 -- duo screen
        if displayplayers[0] == player -- player 1
            v.drawString((320-105), (200/2-30), "ACL \n  " + player.DoAE.RedDice, V_REDMAP|V_SNAPTORIGHT, "thin-center")
            v.drawString((320-80), (200/2-30), "INV \n  " + player.DoAE.SilverDice, V_SNAPTORIGHT, "thin-center")
            v.drawString((320-55), (200/2-30), "DFT \n  " + player.DoAE.GreenDice, V_GREENMAP|V_SNAPTORIGHT, "thin-center")
            v.drawString((320-30), (200/2-30), "SPD \n  " + player.DoAE.BlueDice, V_BLUEMAP|V_SNAPTORIGHT, "thin-center")
        elseif displayplayers[1] == player -- player 2
            v.drawString((320-105), (200-30), "ACL \n  " + player.DoAE.RedDice, V_REDMAP|V_SNAPTOBOTTOM|V_SNAPTORIGHT, "thin-center")
            v.drawString((320-80), (200-30), "INV \n  " + player.DoAE.SilverDice, V_SNAPTOBOTTOM|V_SNAPTORIGHT, "thin-center")
            v.drawString((320-55), (200-30), "DFT \n  " + player.DoAE.GreenDice, V_GREENMAP|V_SNAPTOBOTTOM|V_SNAPTORIGHT, "thin-center")
            v.drawString((320-30), (200-30), "SPD \n  " + player.DoAE.BlueDice, V_BLUEMAP|V_SNAPTOBOTTOM|V_SNAPTORIGHT, "thin-center")
        end

    elseif splitscreen >= 2 -- quator screen
        if displayplayers[0] == player -- player 1
            v.drawString((320/2-105/2), (200/2-30/2), "A\n" + player.DoAE.RedDice, V_REDMAP, "small-center")
            v.drawString((320/2-80/2), (200/2-30/2), "I\n" + player.DoAE.SilverDice, 0, "small-center")
            v.drawString((320/2-55/2), (200/2-30/2), "D\n" + player.DoAE.GreenDice, V_GREENMAP, "small-center")
            v.drawString((320/2-30/2), (200/2-30/2), "S\n" + player.DoAE.BlueDice, V_BLUEMAP, "small-center")
        elseif displayplayers[1] == player -- player 2
            v.drawString((320-105/2), (200/2-30/2), "A\n" + player.DoAE.RedDice, V_REDMAP|V_SNAPTORIGHT, "small-center")
            v.drawString((320-80/2), (200/2-30/2), "I\n" + player.DoAE.SilverDice, V_SNAPTORIGHT, "small-center")
            v.drawString((320-55/2), (200/2-30/2), "D\n" + player.DoAE.GreenDice, V_GREENMAP|V_SNAPTORIGHT, "small-center")
            v.drawString((320-30/2), (200/2-30/2), "S\n" + player.DoAE.BlueDice, V_BLUEMAP|V_SNAPTORIGHT, "small-center")
        elseif displayplayers[2] == player -- player 3
            v.drawString((320/2-105/2), (200-30/2), "A\n" + player.DoAE.RedDice, V_REDMAP|V_SNAPTOBOTTOM, "small-center")
            v.drawString((320/2-80/2), (200-30/2), "I\n" + player.DoAE.SilverDice, V_SNAPTOBOTTOM, "small-center")
            v.drawString((320/2-55/2), (200-30/2), "D\n" + player.DoAE.GreenDice, V_GREENMAP|V_SNAPTOBOTTOM, "small-center")
            v.drawString((320/2-30/2), (200-30/2), "S\n" + player.DoAE.BlueDice, V_BLUEMAP|V_SNAPTOBOTTOM, "small-center")
        elseif displayplayers[3] == player -- player 4
            v.drawString((320-105/2), (200-30/2), "A\n" + player.DoAE.RedDice, V_REDMAP|V_SNAPTOBOTTOM|V_SNAPTORIGHT, "small-center")
            v.drawString((320-80/2), (200-30/2), "I\n" + player.DoAE.SilverDice, V_SNAPTOBOTTOM|V_SNAPTORIGHT, "small-center")
            v.drawString((320-55/2), (200-30/2), "D\n" + player.DoAE.GreenDice, V_GREENMAP|V_SNAPTOBOTTOM|V_SNAPTORIGHT, "small-center")
            v.drawString((320-30/2), (200-30/2), "S\n" + player.DoAE.BlueDice, V_BLUEMAP|V_SNAPTOBOTTOM|V_SNAPTORIGHT, "small-center")
        end
    end



    -- x 320, y 200
    --------------------------------------------------------------------------
    -- Draft in position
    if modeattacking == false
        local mydraftdice = nil
        if leveltime > TICRATE*3 and leveltime-starttime < -TICRATE*3
            for i = 0,6 do
                --local somedraft = nil;
                if DoAE_DraftTable[i+1].DoAEvalue == 0
                mydraftdice = v.getSpritePatch(SPR_BCMSA0, 0)
                elseif DoAE_DraftTable[i+1].DoAEvalue == 1
                mydraftdice = v.getSpritePatch(SPR_BCMSB0, 1)
                elseif DoAE_DraftTable[i+1].DoAEvalue == 2
                mydraftdice = v.getSpritePatch(SPR_BCMSC0, 2)
                elseif DoAE_DraftTable[i+1].DoAEvalue == 3
                mydraftdice = v.getSpritePatch(SPR_BCMSD0, 3)
                elseif DoAE_DraftTable[i+1].DoAEvalue == 4
                mydraftdice = v.getSpritePatch(SPR_BCMSE0, 4)
                elseif DoAE_DraftTable[i+1].DoAEvalue == 5
                mydraftdice = v.getSpritePatch(SPR_BCMSF0, 5)
                elseif DoAE_DraftTable[i+1].DoAEvalue == 6
                mydraftdice = v.getSpritePatch(SPR_BCMSG0, 6)
                end

            
                --table.insert(mydraftdice, somedraft)
                --print(mydraftdice)
                
                v.drawScaled(FRACUNIT*(320/2-50)+(FRACUNIT*18*i), FRACUNIT*(200-30), FRACUNIT/2, mydraftdice, V_SNAPTOBOTTOM, v.getColormap(0, DoAE_DraftTable[i+1].color))
            end
                v.drawString((320/2), (200-50), "Today's Draft", 0, "center")
        end
    end
end

hud.add(Badgerhud, "game" )